
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何开发一个可复用的软件系统 / iVAN</title>

    <meta name="description" content="如何开发一个可复用的软件系统 如何创建一个可复用软件系统 译者序:本文是设计模式&quot;Template Method&quot;模板方法的一个延伸,将模板应用到了整个软件开发产品.首先将软件产品核心不变的业务逻辑部分抽象出来,对于在不同产品中的不同的部分,核心产品通过钩子调用钩子组件重的具体实现,这样开发不同的系统时,只要更改钩子组件的内容就实现了不同的产品.开发的关键就是抽象核心产品的功能.当然这种开发思想也是局限的,不是适合所有的开发项目(抽象所有项目的核心是没有意义的),这种开发思路比较适合针对于一个领域的产品开 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何开发一个可复用的软件系统</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>如何创建一个可复用软件系统</p>
<p>译者序：本文是设计模式“Template Method”模板方法的一个延伸，将模板应用到了整个软件开发产品。首先将软件产品核心不变的业务逻辑部分抽象出来，对于在不同产品中的不同的部分，核心产品通过钩子调用钩子组件重的具体实现，这样开发不同的系统时，只要更改钩子组件的内容就实现了不同的产品。开发的关键就是抽象核心产品的功能。当然这种开发思想也是局限的，不是适合所有的开发项目（抽象所有项目的核心是没有意义的），这种开发思路比较适合针对于一个领域的产品开发，同一个领域抽象出来的核心产品才有实际的使用价值。</p>
<p>创建可复用的组件是学习如何创建可复用程序的第一步――――by Mike Cahn</p>
<p>如果你连续的开发几个软件项目，将会发现自己编写了许多重复功能的代码，当你认识到这点，你肯定会产生复用代码的想法。事实上很多开发团队都建立了自己的代码库和组建库以方便的将他们应用到新的项目中。下面我将讲述如何将复用提高到一个更高的级别：复用整个应用程序</p>
<p>如果你开发一个particular business函数或者specific vertical market,你就会发现客户的需求之间存在着很多重复使用核心代码的组件的重叠，但是需求之间的不同点却要求你不得不为每一个客户开发一个全新的系统</p>
<p>尤其不幸的是重写会增加设计和开发时间还有更复杂的维护，例如如果你存在多个版本，你就会面对这样的问题：传播一个bug修复、产品增加功能要求为每一个客户指定更改和测试，复用组建帮助等！但是如果所有应用程序的核心逻辑是相同的，那为什么不更好的复用这部分核心逻辑呢？</p>
<p>答案是你当然可以做到，开发一个核心产品，然后在不同的功能层之间你都可以使用它而没有必要改变核心代码</p>
<p>什么是钩子？</p>
<p>一个钩子就是你设置客户实例化代码的地方，它是一个丛核心产品调用到定制组件的方法，一个客户化层（钩子组件）需要知道正在发生什么的地方，或者需要修改核心产品行为的地方，你的核心产品都可以使用钩子调用</p>
<p>典型的应用是：一个钩子方法通过数据和钩子组件当前的上下文关联性进行调用，钩子组件处理这个调用以返回正确的信息</p>
<p>当设计核心产品和钩子组件时，你要让它们尽量保持松耦合关系，将来如果核心产品发生变化不会影响已经配置的钩子组件。你也要必须保证在配置钩子组件时，核心产品增加计划范围之外新的钩子调用后 钩子组件也能执行正确的事件</p>
<p>确定核心功能：</p>
<p>使用钩子创建一个核心应用程序时，评定的第一步就是确定哪些东西将要作为核心来处理，如果核心产品设置了太少的功能，那么你将不得不针对每一个项目重复执行通用的功能，这样增加了很大的工作量！重复的代码操作破坏了核心应用程序开发的目的。但是如果包括了不是所有客户都有的通用功能将是更糟糕事情，所有开发项目在使用核心代码时都会产生很多问题，最后你将不得不修改核心产品</p>
<p>核心产品后期增加可移植的功能比从中移除本来就不应该加入的功能要有益的多，不过这样可能会产生过于保守的错误！能够适合核心产品的功能性能够作为一个可以共享的组件产生，当你做好准备时你也可以移植它</p>
<p>确定核心应用程序功能性（functionality）最关键的是定义个一个所有客户都通用的程序流，让我们来看一个例子，假设你正在开发三个系统，它们都有一个基于移动工作项目的工作流，在这三个系统中用户都可以通过执行“下一步”，从一个工作项目执行到下一个工作项目，下面是这三个系统的详细不同点：</p>
<p>系统1：这个系统仅仅是移动工作项目到下一步，但是不执行任何操作</p>
<p>系统2：系统在一个授权（legacy）系统中记录工作项目和操作步骤的详细信息，同时写入一个从授权（legacy）的系统到工作项目内部的引用关键字</p>
<p>系统3：系统在工作项目移动到下一步之前显示一个用于用户更新的复选框，如果用户标志的所有必须的操作没有成功的完成时，系统撤销操作“下一步”操作</p>
<p>图表1显示了功能化是如何在核心产品和三个不同的客户化层之间划分的，在这个例子中</p>
<p>客户化层需要下面的能力：</p>
<p>使用和更新核心产品对象（在这个例子中指工作项目）</p>
<p>用使用者进行交互</p>
<p>改变核心产品的工作流（比如撤销当前操作）</p>
<p>连接其他应用程序或者组件</p>
<p>这些需求是很典型的，你要在你的核心产品的所有函数中考虑到</p>
<p>构建钩子接口：</p>
<p>在钩子组件内部设置的参数依赖上下文改变，要比维护一堆钩子接口强的多，所以创建一个通用的钩子接口是较好的解决方案. 使用变量集合或者参数数组适应你将加入的不同数据类型，在第一个参数中存储钩子的标志符，钩子组件工作的第一件事就是解释这个标志符然后调用相应的函数或者组件，下面的代码通过使用select …..case 结构实现了这一功能：</p>
<p>列表1：核心产品调用钩子组件（一个很小的钩子组件）</p>
<p>'Constants would normally be defined in a module or class<br />   Const NEXTSTEP_START = "NS-START"<br />   Const NEXTSTEP_SELECTED = "NS-SELECTED"<br />   Const HOOK_OK = "OK"<br />   Const HOOK_CANCEL = "CANCEL"<br />   '...</p>
<p>'User just selected Next Step operation<br />   sHookResponse = mobjHookComponent.CallIn(NEXTSTEP_START, _<br />   mobjCurrentItem, mobjCurrentUser, "")<br />   ...<br />   'User just selected the Step to move the item to<br />   sHookResponse = mobjHookComponent.CallIn(NEXTSTEP_SELECTED, _<br />   mobjCurrentItem, mobjCurrentUser, sSelectedStep)</p>
<p>Hook component Code:<br />   'Note: Hook constants file would need to be included</p>
<p>Function CallIn(ByVal sHookId as String, vParam1 as Variant, _<br />   vParam2 as Variant, vParam3 as Variant) as String</p>
<p>Dim sReturnValue    as String<br />   Dim objWorkitem    as clsWorkitem<br />   Dim objUser      as clsUser<br />   Dim sSelectedStep   as String</p>
<p>On Error Goto CallIn_Handler</p>
<p>Select Case sHookId</p>
<p>Case NEXTSTEP_START<br />      'Processing to be done when NextStep is first invoked<br />      Set objWorkitem = vParam1<br />      Set objUser = vParam2<br />      Call WriteLog( sHookId, "Item ID: " &amp; _<br />         objWorkitem.WorkitemID &amp; ", User ID: " &amp; _ <br />         objUser.UserID )<br />         sHookId = HOOK_OK<br />   Case NEXTSTEP_SELECTED<br />      Set objWorkitem = vParam1<br />      Set objUser = vParam2<br />      sSelectedStep = vParam3<br />      Call WriteLog( sHookId, "Item ID: " &amp; _<br />        objWorkitem.WorkitemID &amp; ", User ID: " &amp; _<br />        objUser.UserID &amp; ", Step: " &amp; vParam3 )</p>
<p>'...do whatever processing is required...<br />         sHookId = HOOK_OK</p>
<p>Case else<br />      'Unknown hook, possibly introduced to product <br />      ' after this component was written. <br />      'Just allow it, but do nothing.<br />      Call WriteLog( sHookId, "Unrecognised Hook" )<br />      sReturnValue = HOOK_OK   <br />   End Select</p>
<p>CallIn = sReturnValue</p>
<p>Exit Function</p>
<p>CallIn_Handler:<br />   'Handle the error...</p>
<p>End Function</p>
<p>Sub WriteLog( sHookID as String, sText as String )<br />             Dim sFullText as String</p>
<p>sFullText = Time$ &amp; " " &amp; sHookID &amp; " " &amp; sText</p>
<p>Debug.Print sFullText</p>
<p>'Log to file used mainly for testing <br />      'and for diagnosing production systems<br />      If IsFileLoggingOn(sHookID) then<br />         'Output log info to text file...<br />      End If<br />   End Sub （to be continue )</p>
<p>你也可以使用你熟悉的com 实现这个功能，他们通过分派调用方法的技术很相似</p>
<p>你在发行新版本的核心产品时必须保证不需要重新编译已经存在的钩子组件，所以钩子组件应该忽视所有没有被公认的钩子标志符而且仅仅返回一个简单的“成功”代码（参考代码列表的case else 部分），通过这个方法，钩子组件只需为功能需求执行被认可的钩子调用，如果日后需要为核心产品增加新的钩子调用点时，既有的钩子组件不需要改变任何行为就可以增加新的钩子标志符</p>
<p>在“下一步”的例子中，核心产品可能在几个执行点调用钩子，例如：当用户请求下一步操作然后选择步骤名称再次请求，这两个例子将会是：</p>
<p>Hook <br /> Param1 <br /> Param2 <br /> Param3 <br /> Param4</p>
<p>Next step Started<br /> "NS-START"<br /> objUser<br /> objWorkitem<br /> ""</p>
<p>Next step Step Selected<br /> "NS-SELECTED"<br /> objUser<br /> objWorkitem<br /> sStepName</p>
<p>这样简单的一个例子，三个变量（加上钩子标识符）可能就已经足够了，可是为了避免了将</p>
<p>来接口改变带来的麻烦，你总是不得不增加更多的函数，列表1显示了一个核心产品的简单</p>
<p>代码：一个钩子组件，一个钩子的调用实例</p>
<p>为了执行客户三个复选框的功能，你应该从钩子组件项目中添加一个复选框窗体，并且通过</p>
<p>下面代码调用：</p>
<p>Case NEXTSTEP_SELECTED</p>
<p>'...Cast variables and Call WriteLog()...</p>
<p>'Show the checklist<br />      frmChecklist.Show vbModal <br />      If frmCheckList.AllRequiredItemsTicked Then<br />         sReturnValue = HOOK_OK<br />      Else<br />      MsgBox "You have not ticked all the " &amp; _<br />         "required items.  " &amp; _<br />         "Next Step cannot continue", vbExclamation<br />         Call WriteLog( sHookId, "Cancel sent back -- " &amp; _<br />         "all required items not ticked" )<br />         sReturnValue = HOOK_CANCEL<br />      End If<br />      ' ... more code<br />钩子组件影响核心产品：</p>
<p>核心产品为可能发生变化的需求设置点，然后将对他们的控制委托给钩子组件，接着响应钩</p>
<p>子组件返回的状态，</p>
<p>数据对象引用</p>
<p>当钩子组件接收到一个对数据对象的引用时，核心产品需要捕获钩子组件引起了什么变化，</p>
<p>如果你不想钩子组件修改一个对象的参数，可以通过使用一个宣传对象或者锁对象，或者一</p>
<p>个在调用方法前设置部分特性的对象，如果你允许改变，对象可以验证他们，或者记录他们，</p>
<p>当方法返回时通过核心产品验证他们，例如用户需要用两个钩子更新一个有引用关键字的工</p>
<p>作项目</p>
<p>Case NEXTSTEP_SELECTED<br />      '...cast variables and call WriteLog()...<br />      sRefKey = GetMainframeKey(objWorkitem.WorkitemID)<br />      objWorkitem.Reference = sRefKey<br />      sReturnValue = HOOK_OK   <br />然后核心产品可以查询返回的工作项目对象：</p>
<p>mobjCurrentItem.ResetChangedFlag</p>
<p>sHookResponse = _<br />      mobjHookComponent.CallIn(NEXTSTEP_SELECTED, _<br />      mobjCurrentUser, mobjCurrentItem, sSelectedStep)</p>
<p>If mobjCurrentItem.Changed then<br />      'Take appropriate action, such as validating <br />   'and/or saving the changes...<br />   End If<br />逻辑控制</p>
<p>钩子组件可以返回影响核心产品逻辑的值，这种执行方法是很有限的，例如：可以指定</p>
<p>一组钩子组件返回的标志（取消当前操作，显示标准对话框），否则你的核心产品和钩子组</p>
<p>件就会产生紧耦合危险。通过预定义一组客户之间不需要改表的标志，你就可以为核心产品</p>
<p>捕获任何可能返回的值</p>
<p>使用交互</p>
<p>在一个基于windows 窗体的典型应用程序中，钩子组件可以用vb窗体发行，当用户需要时</p>
<p>交互调用</p>
<p>对于web应用程序，核心产品和钩子组件需要在服务器上运行，所以vb 窗体就不适用了，</p>
<p>不过你可以用下面的几种方法 ：</p>
<p>通过为核心产品返回一个url ,来调用一个新的window浏览器，将一个调用浏览窗口的</p>
<p>Url 返回给核心产品，所有从这个窗口的后继请求都能被非核心调用。因为这个窗口是非模</p>
<p>式化的，所以用户很清楚的在核心产品屏幕和钩子窗口间进行嵌套</p>
<p>第一步操作的一个变量用一个钩子的url内容临时替换核心产品的浏览器，这是一个很</p>
<p>有效的模式接口，通过屏幕的请求可以被定制的组件捕获，当控制被返回到核心产品时，控</p>
<p>制可以存储自己的屏幕</p>
<p>返回一个html 或者xml 给核心产品，可以合并成正在创建的页面，这使得钩子接口通</p>
<p>过使用核心产品而变得更好，然而核心产品不得不将请求从屏幕的钩子部分转化为相应的定</p>
<p>制组件</p>
<p>实践：</p>
<p>二进制兼容性确保了你的核心产品和钩子组件总是使用相同的接口，可以在办公室特定</p>
<p>的电脑上记录你创建的核心产品，项目小组也经常在站点上创建钩子组件，使任何计算机</p>
<p>都变得可用。这样有时候可以引起二进制很难修复的问题，如果你这样运行，要尽量同步</p>
<p>这两个创建环境，尽量包含服务组件。如果还是不能正常工作，也可以放弃二进制兼容性，</p>
<p>使用更缓慢的后期绑定作为最后的手段</p>
<p>测试：</p>
<p>钩子组件提供很有用的调试和测试帮助，就像演示过的那样，你的基本钩子组件分之应该要记录所有的调用和参数，响应每个钩子的典型方法是为每一个客户定制代码，然而即使是一个内部使用，编写一个可配置的钩子组件也是值得的。组件的行为不是硬编码的，它的响应是通过list2配置文件控制的（使用xml 文件是因为他可以包含一个可分级的信息）。你已经编写了一个可配置的钩子组件，你为了测试不同的情形而不得不改变它，你将只需要修改这个配置文件。这样的修改对开发者是很容易的，对测试者也有很显著的用处，他们都不用修改代码。</p>
<p>你的可配置钩子允许你可以为每一个钩子标志符指定不同的返回值，通过为每一个基本用户定义行为的例子精确到了一比特。我还添加了一个暂停设置和用于显示的消息框，这对模拟延迟是很用的，</p>
<p>最后我还添加了一个解释钩子组件如何改变传入参数的设置（请看代码列表2）</p>
<p>发布：</p>
<p>如果没有除了日志记录以外的功能，一定要记住你必须至少提交和核心产品一致的钩子组件分支，因为你的核心产品需要能够调用执行它</p>
<p>更多的参考：</p>
<p>这个钩子概念是基于”模板”设计模式的，如果你没有听过这个设计模式，你应该读“设计模式”这本书，他们假设你使用的是一个有完全继承功能的语言，虽然这不是必要的。通过vb.net  我们可以实现，vb60通过一点点努力也可以实现这个目的如果你感觉这个文章有点难，你可以从Stamatakis 编写的“vb设计模式”开始，虽然它没有覆盖所有的模式，但是他对于vb开发者来说是一个很好的开始</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 00:08:43</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e4%ba%a7%e5%93%81/" title="产品">产品</a>, <a href="https://www.iamivan.net/tag/%e7%bb%84%e4%bb%b6/" title="组件">组件</a>, <a href="https://www.iamivan.net/tag/%e6%a0%b8%e5%bf%83/" title="核心">核心</a>, <a href="https://www.iamivan.net/tag/%e9%a1%b9%e7%9b%ae/" title="项目">项目</a>, <a href="https://www.iamivan.net/tag/%e9%92%a9%e5%ad%90/" title="钩子">钩子</a>, <a href="https://www.iamivan.net/tag/%e5%b7%a5%e7%a8%8b%e9%a1%b9%e7%9b%ae%e5%a4%8d%e7%94%a8/" title="工程项目复用">工程项目复用</a>, <a href="https://www.iamivan.net/tag/%e9%92%a9%e5%ad%90java-web/" title="钩子java web">钩子java web</a>, <a href="https://www.iamivan.net/tag/%e5%88%9b%e5%bb%ba%e5%8f%af%e5%a4%8d%e7%94%a8%e7%bb%84%e4%bb%b6/" title="创建可复用组件">创建可复用组件</a>, <a href="https://www.iamivan.net/tag/%e5%8f%af%e5%a4%8d%e7%94%a8%e7%bb%84%e4%bb%b6/" title="可复用组件">可复用组件</a>, <a href="https://www.iamivan.net/tag/%e6%a0%b8%e5%bf%83%e6%96%b9%e6%b3%95/" title="核心方法">核心方法</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何开发一个可复用的软件系统的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YDPoM.html" rel="bookmark">动手开发一个名为&OpenCurlyDoubleQuote;微天气&rdquo;的微信小程序（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言:在智能手机软件的装机量中,天气预报类的APP排在比较靠前的位置.说明用户对天气的关注度很高.因为人们无论是工作还是度假旅游等各种活动都需要根据自然天气来安排.跟着本文开发一个&quot;微天气&quot;小程序,方便微信网友随时查看天气. 接下来两天小编将同您一起开发一个&quot;微天气&quot;小程序,本文首先向大家介绍&quot;微天气&quot;的API与界面代码编写.本文选自&lt;从零开始学微信小程序开发&gt;. 在一套软件系统中,微信小程序通常是作为前端来使用的,一般还需要有后端的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7WKoKz.html" rel="bookmark">自己动手开发一个 Web 服务器（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自己动手开发一个 Web 服务器(一) 有一天,一位女士散步时经过一个工地,看见有三个工人在干活.她问第一个人,&quot;你在做什么?&quot;第一个人有点不高兴,吼道&quot;难道你看不出来我在砌砖吗?&quot;女士对这个答案并不满意,接着问第二个人他在做什么.第二个人回答道,&quot;我正在建造一堵砖墙.&quot;然后,他转向第一个人,说道:&quot;嘿,你砌的砖已经超过墙高了.你得把最后一块砖拿下来.&quot;女士对这个答案还是不满意,她接着问第三个人他在做什么.第三个人抬头看着天空			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM6NQXM.html" rel="bookmark">插件-开发一个云处理平台，从开发到运行需要多久时间，开发资金需要多少</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 开发一个云处理平台,从开发到运行需要多久时间,开发资金需要多少 在云服务器中存储大量vst插件,多个本地端通过云端同时调用多个不同或相同的vst插件进行使用.想问的让本地用户编辑云端上的vst插件有什么方法,怎么实现多人同时公用不同或相同的vst插件.开发周期大概需要多久,开发资金需要多少?本人没有一点程序基础.只是有这么一个想法.希望各位大师能帮我看看这个想法可不可能实现. 解决方案 估算了下,大约需要1个架构师,3个程序员开发大约3~4个月,开发费用大约40~70万人民币.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MWl9np.html" rel="bookmark">真心求教关于自动化Web请求的开发问题，类似于开发一个12306桌面抢票软件，具体请进呢</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 真心求教关于自动化Web请求的开发问题,类似于开发一个12306桌面抢票软件,具体请进呢 Web开发确实是博大精深,因为目前个人是开发手游,因为某些原因需要暂时做这么一个东西,但时间的问题不太允许我深入的研究Web开发,所以特来求教各位大神,我需要做的这个东西和之前一直流传的12306桌面抢票软件很像.就是根据某些网站写一个外挂软件,让一些需要手动完成的操作,代码来自动完成. 刚开始我以为Web请求一般都用一个拼接好的url直接访问,然后获得一些数据,接着再处理这些数据就好了.但事实证			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgwjZM.html" rel="bookmark">语音识别-想开发一个点名软件，不知道语音这块应该怎么解决？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 想开发一个点名软件,不知道语音这块应该怎么解决? 是说有个微软的语音库吗?没有用过啊,做过的大神们给点启发吧.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvYn5b.html" rel="bookmark">从使用Python开发一个Socket示例说到开发者的思维和习惯问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天主要说的是一个开发者的思维和习惯问题. 思维包括编程的思维和解决一个具体问题的分析思维,分析思路,分析方法,甚至是分析工具. 无论是好习惯还是不好的习惯,都是在者一天一天的思维中形成的.那些不好的习惯,久了确实不好改.所以说,如果今天你认识到了,那么就从今天开始改,早改早受益,晚改痛苦一生. 先说一下今天的引子,那就是使用Python开发一个简单的Socket应用,就是一个client/server通信的小例子. 假设现在需要我们使用python开发一个socket的聊天应用,可能会遇到下面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp59d7p.html" rel="bookmark">开发一个调试JSP的Eclipse插件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js 本文通过开发一个JSP 编辑器插件的示例,介绍了 Eclipse 中设置 JSP 断点的方法,以及如何远程调试 JSP.作为基础知识,本文的前两部分描述了 JAVA Debug 和 JSR-45 的基本原理. 环境要求: 本文的代码是在 Eclipse3.0.0,JDK1.4.2 和 Tomcat5.0.5 上测试过的. JAVA 调试框架(JPDA)简介 JPDA 是一个多层的调试框架,包括 JVMDI.JDWP.JDI 三个层次.JAVA 虚拟机提供了 JPDA 的实现.其开发工具作为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/4MYDdQb.html" rel="bookmark">用ASP开发一个在线考试系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在线 本文所介绍的应用程序是以ASP编程的初学者为读者的.虽然这个例子非常简单,但是它对于那些试图在线对他们的雇员.学生或客户进行考试的组织是非常有用的. 关于这个应用程序 我们的应用程序中的第一个界面包含在index.asp 中,由一个注册页组成,其中有两个输入域,一个是用户名,另一个是口令.非会员要想参加考试的话必须要注册.这一页是初始屏幕,为用户提供用户名和口令的输入框. 开发一个在线考试系统-asp在线考试系统&quot;&gt; 需要注意的是,这两个将要批准的会员域应该有客户机端的JavaScr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1Mv3Z9p.html" rel="bookmark">如何开发一个多种语言版本的C&num;程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序 在C#中有多种使用资源文件的方法,能够很方便地开发全球通用的应用程序.本文通过一个简单的小例子,来讲解在C#中如何利用资源文件,快速开发一个多种语言版本的程序.本例中只有一个窗体,三个控件,能够根据用户的设置以中文或英文界面运行.开发环境是Windows 2000 Professional.Microsoft Visual Studio.NET 2002.具体开发步骤如下: 一.新建项目 启动Microsoft Visual Studio .NET,新建一个C#项目MyApp,本例工程存放			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGOenz.html" rel="bookmark" class="title">10条建议 着手开始Web2&period;0实施</a>
					<div>
						专家精选10条建议助你着手构建一个更动态的Web站点,跃入Web2.0时代-- 如今Web2.0的宣传铺天盖地,很难找到一个可靠的策略来让公司的网站更加动态.在这里我们给出10条建议,这些建议均来源于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3n6Wz.html" rel="bookmark" class="title">快速提升网站SEO健康度四：网站关键词健康</a>
					<div>
						  大家好,我是上海网站建设协策网络的木子成舟.对于网站SEO健康度,前面已经为大家谈到三个方面&lt;快速提升网站SEO健康度一:网站内容健康&gt;&lt;快速提升网站SEO健康度二:网站硬件健康 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPBKwz.html" rel="bookmark" class="title">如何节省windows 7系统硬盘空间</a>
					<div>
						装完windows7系统之后,即便未安装任何应用程序C盘占用空间已达到10G以上.其实有一些东西可能是我们不需要的,如果可以将一些 我们不需要的东西从硬盘里去除而且不影响系统运行,岂不是大大节约了空间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo60Jgz.html" rel="bookmark" class="title">实现标题条的显示与隐藏</a>
					<div>
						有时候为了实际的显示面积大一些或其他的一些原因需要对标题条进行隐藏或显示.本文使用一个简单的例子,说明如何在MFC应用程序的框架下来实现它.其中使用API的方法也可用于其他的Windows应用开发环境 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr10lp.html" rel="bookmark" class="title">linux基础命令&lpar;38&rpar; cal命令</a>
					<div>
						cal命令可以用来显示公历(阳历)日历.公历是现在国际通用的历法,又称格列历,通称阳历.&quot;阳历&quot;又名&quot;太阳历&quot;, 系以地球绕行太阳一周为一年,为西方各国所通用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKe33M.html" rel="bookmark" class="title">Access如何在字段定义主键</a>
					<div>
						  1.打开你的access,并打开你要设置主键的数据表,然后点击 开始--视图. 2.在视图的下拉菜单中,点击 设计视图. 3.来到了设计视图面板,我们在要设立主键的字段的右边,也就是红色箭头的位置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRynRz.html" rel="bookmark" class="title">添加删除不能打开怎么办</a>
					<div>
						方法1:注册表法 打开&quot;注册表编辑器&quot;,展开分支&quot;HKEY_CURRENT_USERSoftwareMicrosoftWindo wsCurrentVersionPoli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq836Gb.html" rel="bookmark" class="title">无法进入BIOS设置</a>
					<div>
						  在启动电脑后,按[Del]键无法进入BIOS的设置中,屏幕提示&quot;unknown flash type,system halt&quot;的错误提示,然后就死机了. 这种情况可能是CMOS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42EPLM.html" rel="bookmark" class="title">iOS中动态更新补丁策略JSPatch运用基础二</a>
					<div>
						iOS中动态更新补丁策略JSPatch运用基础二 一.引言     上篇博客中介绍了iOS开发中JSPatch引擎进行动态热修复的一些基础功能,其中包括向Objective-C类中添加类方法与成员方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKaD4M.html" rel="bookmark" class="title">走出浮躁的泥沼：关于技术与工作</a>
					<div>
						关于技术与工作 我觉得,技术与工作最理想的结合状态是,自己能学习到新的技术,这些技术也能应用到工作中:工作的内容又不那么枯燥,都那么具有挑战性. 程序员的工作首先应该是富有挑战性的 有这么一句名言:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7QANM.html" rel="bookmark" class="title">windows启动引导修复</a>
					<div>
						windos启动引导修复的工具可以更深层次的修复启动引导项,特别是在使用其它工具无法修复启动引导项的情况下,bootice引导管理工具就可以解决这样的问题,登录不了系统等问题 插上U启动U盘,在开机界 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YGWqM.html" rel="bookmark" class="title">Hbase简介和基本用法</a>
					<div>
						一.简介 history  started by chad walters and jim 2006.11 G release paper on BigTable 2007.2 inital HBas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8k0a9M.html" rel="bookmark" class="title">Android 表单验证开源框架 saripaar</a>
					<div>
						下载地址: https://github.com/ragunathjawahar/android-saripaar Android Saripaar சரிபார் - sari-paar (Tami ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QDvjp.html" rel="bookmark" class="title">Mvc 一个视图怎么绑定多个模型</a>
					<div>
						问题描述 在这里的9楼提到了,就是我要的,但是不太明白什么是自定义模型http://bbs.csdn.net/topics/370151723MVC3里面怎么在一个视图里面显示多个模型,也就是如果在一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWklWp.html" rel="bookmark" class="title">【原创】Matlab&period;NET混合编程技巧之找出Matlab内置函数</a>
					<div>
						              本博客所有文章分类的总目录:[总目录]本博客博文总目录-实时更新    Matlab和C#混合编程文章目录 :[目录]Matlab和C#混合编程文章目录 Matlab与.N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rBd8p.html" rel="bookmark" class="title">java 执行linux命令判断某个文件是否存在</a>
					<div>
						问题描述 java 执行linux命令判断某个文件是否存在 java用sshxcute 连接linux服务器,判断一个某个路径下的某个文件或文件夹是否存在? 给出返回值. 解决方案 http://ww ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB1LAb.html" rel="bookmark" class="title">轻松获得alexa新版5星级评价</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 今天alexa做了个小改动,增加星 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEK8kM.html" rel="bookmark" class="title">HTTPS原理</a>
					<div>
						HTTPS是什么 HTTPS全称为Hypertext Transfer Protocol over Secure Socket Layer,及以安全为目标的HTTP通道,简单说就是HTTP的安全版本. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLgkVp.html" rel="bookmark" class="title">C语言可变参实现参数累加返回</a>
					<div>
						C语言可变参的作用真的是非常大,自从发表了可变参如何实现printf,fprintf,sprintf的文章以来,便有不少博友私信问我实现的机制,我也解释了相关的知识点.今天,我们借着这个机会,再来举一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmDK8M.html" rel="bookmark" class="title">代码-c&num; webbrowser通过获得网页元素疑问</a>
					<div>
						问题描述 c# webbrowser通过获得网页元素疑问 我在百度上找的代码: 这个可以获得鼠标的坐标,但是不能获得网页的元素,好像是鼠标没有点击到webbrowser网页 1.在适当的位置执行以下代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdR126b.html" rel="bookmark" class="title">React Native开发之ATOM开发实用技巧</a>
					<div>
						前面对React Native开发工具Atom做了一个详细的介绍,详见RN开发IDE详解. Atom作为一款前端开发利器,有很多的插件供我们选择,这里罗列常见的可以提高我们开发效率的插件给大家介绍一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBo9qb.html" rel="bookmark" class="title">食品饮料行业不吹不行 业内前十名年广告投放近百亿</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 截至4月最后一个交易日,上市公司2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22x5Vb.html" rel="bookmark" class="title">tomcat启动，闪一下就没了，怎么回事？</a>
					<div>
						问题描述 解决方案 解决方案二:看一下$tomcat/logs目录下有什么错误日志.解决方案三:你是没配环境变量然后直接双击打开了么?这样好像不行的解决方案四:将tomcat下面的logs,work和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgXv8M.html" rel="bookmark" class="title">weblogic jms消息丢失的问题</a>
					<div>
						问题描述 因需要对应用程序jms处理能力做压力测试,找了个压力测试工具(JMeter)进行压力测试,发现个问题:发现一次发送多条消息,应用程序收到消息比实际发送条数少一些,但如果在weblogic设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye96vM.html" rel="bookmark" class="title">2011年中国网民在线购物交易额达到7849&period;3亿元</a>
					<div>
						全球著名调研机构IDC和阿里巴巴集团研究中心日前联合发布的&lt;中国电子商务服务业白皮书&gt;显示,2011年中国网民在线购物交易额达到7849.3亿元,同比增长约66%.全年社会消费品零售总额实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22LAvb.html" rel="bookmark" class="title">HDU 1263 水果</a>
					<div>
						水果 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submiss ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwqxZM.html" rel="bookmark" class="title">spring ide-myeclipse中手动配置的spring项目如何加入spring IDE中</a>
					<div>
						问题描述 myeclipse中手动配置的spring项目如何加入spring IDE中 在myeclipse中手动配置的spring项目如何加入spring IDE中?(PS:右击项目没有找到spri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22gwQb.html" rel="bookmark" class="title">WinForm修改App&period;config配置文件功能</a>
					<div>
						WinForm修改App.config配置文件主要是通过System.Configuration.dll里ConfigurationManager类来实现,在功能开发前是需要手动引用该dll文件. C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLqDNM.html" rel="bookmark" class="title">c&num;&period;net-用&period;net连接sqlserver数据库查询特定字段（字段名以某特定字符串开头）</a>
					<div>
						问题描述 用.net连接sqlserver数据库查询特定字段(字段名以某特定字符串开头) 数据库sqlserver中有一张表,表里面有类似于name1,name2,name3.......这类的字段, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQK7Qp.html" rel="bookmark" class="title">智能家居：让家居生活物联网化</a>
					<div>
						智能家居(英文:smarthome,homeautomation)是以住宅为平台,利用综合布线技术.网络通信技术.安全防范技术.自动控制技术.音视频技术将家居生活有关的设施集成,构建高效的住宅设施与家 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
